package dev.shadowsoffire.apotheosis.adventure.affix.reforging;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingRecipe;
import dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingTableBlock;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityRegistry;
import dev.shadowsoffire.placebo.block_entity.TickingBlockEntity;
import dev.shadowsoffire.placebo.cap.InternalItemHandler;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import net.minecraft.core.BlockPos;
import net.minecraft.core.Direction;
import net.minecraft.core.particles.ParticleOptions;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.nbt.Tag;
import net.minecraft.sounds.SoundEvents;
import net.minecraft.sounds.SoundSource;
import net.minecraft.util.RandomSource;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraftforge.common.capabilities.Capability;
import net.minecraftforge.common.capabilities.ForgeCapabilities;
import net.minecraftforge.common.util.LazyOptional;
import net.minecraftforge.items.IItemHandler;
import org.jetbrains.annotations.Nullable;

public class ReforgingTableTile extends BlockEntity implements TickingBlockEntity {
  public int time = 0;
  
  public boolean step1 = true;
  
  protected InternalItemHandler inv = (InternalItemHandler)new Object(this, 2);
  
  LazyOptional<IItemHandler> invCap;
  
  public ReforgingTableTile(BlockPos pWorldPosition, BlockState pBlockState) {
    super((BlockEntityType)Apoth.Tiles.REFORGING_TABLE.get(), pWorldPosition, pBlockState);
    this.invCap = LazyOptional.of(() -> this.inv);
  }
  
  public LootRarity getMaxRarity() {
    return ((ReforgingTableBlock)m_58900_().m_60734_()).getMaxRarity();
  }
  
  public boolean isValidRarityMat(ItemStack stack) {
    DynamicHolder<LootRarity> rarity = RarityRegistry.getMaterialRarity(stack.m_41720_());
    return (rarity.isBound() && getMaxRarity().isAtLeast((LootRarity)rarity.get()) && getRecipeFor((LootRarity)rarity.get()) != null);
  }
  
  @Nullable
  public ReforgingRecipe getRecipeFor(LootRarity rarity) {
    return this.f_58857_.m_7465_().m_44013_(Apoth.RecipeTypes.REFORGING).stream().filter(r -> (r.rarity().get() == rarity)).findFirst().orElse(null);
  }
  
  public void clientTick(Level pLevel, BlockPos pPos, BlockState pState) {
    Player player = pLevel.m_45924_(pPos.m_123341_() + 0.5D, pPos.m_123342_() + 0.5D, pPos.m_123343_() + 0.5D, 4.0D, false);
    if (player != null) {
      this.time++;
    } else {
      if (this.time == 0 && this.step1)
        return; 
      this.time++;
    } 
    if (this.step1 && this.time == 59) {
      this.step1 = false;
      this.time = 0;
    } else if (this.time == 4 && !this.step1) {
      RandomSource rand = pLevel.f_46441_;
      for (int i = 0; i < 6; i++)
        pLevel.m_7106_((ParticleOptions)ParticleTypes.f_123797_, pPos.m_123341_() + 0.5D - 0.1D * rand.m_188500_(), pPos.m_123342_() + 0.8125D, pPos.m_123343_() + 0.5D + 0.1D * rand.m_188500_(), 0.0D, 0.0D, 0.0D); 
      pLevel.m_7785_(pPos.m_123341_(), pPos.m_123342_(), pPos.m_123343_(), SoundEvents.f_11669_, SoundSource.BLOCKS, 0.03F, 1.7F + rand.m_188501_() * 0.2F, true);
      this.step1 = true;
      this.time = 0;
    } 
  }
  
  public void m_183515_(CompoundTag tag) {
    super.m_183515_(tag);
    tag.m_128365_("inventory", (Tag)this.inv.serializeNBT());
  }
  
  public void m_142466_(CompoundTag tag) {
    super.m_142466_(tag);
    this.inv.deserializeNBT(tag.m_128469_("inventory"));
  }
  
  public <T> LazyOptional<T> getCapability(Capability<T> cap, Direction side) {
    if (cap == ForgeCapabilities.ITEM_HANDLER)
      return this.invCap.cast(); 
    return super.getCapability(cap, side);
  }
  
  public void invalidateCaps() {
    super.invalidateCaps();
    this.invCap.invalidate();
  }
  
  public void reviveCaps() {
    super.reviveCaps();
    this.invCap = LazyOptional.of(() -> this.inv);
  }
}
